'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _util = require('./util');

const createDatabase = (client, config, resolve, reject) => {
  client.createDatabase({ id: config.database }, (err, created) => {
    if (err) {
      reject(err);
      return;
    }

    resolve(created);
  });
};

exports.default = (client, config) => new Promise((resolve, reject) => {
  client.readDatabase((0, _util.makeDatabaseUrl)(config), (err, result) => {
    if (err) {
      if (err.code === _util.HTTP_STATUS.NOTFOUND && config.createDatabaseIfNotExists) {
        createDatabase(client, config, resolve, reject);
        return;
      }

      reject(err);
      return;
    }

    resolve(result);
  });
});