'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _documentdb = require('documentdb');

var _database = require('./database');

var _database2 = _interopRequireDefault(_database);

var _collection = require('./collection');

var _collection2 = _interopRequireDefault(_collection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const DEFAULT_CONFIG = {
  uri: null,
  primaryKey: null,
  database: null,
  collections: [],

  createDatabaseIfNotExists: true,
  createCollectionIfNotExists: true,

  collectionDefaultThroughput: 400
};

exports.default = async config => {
  const cosmosConfig = _extends({}, DEFAULT_CONFIG, config);

  const client = new _documentdb.DocumentClient(cosmosConfig.uri, { 'masterKey': cosmosConfig.primaryKey });
  const database = await (0, _database2.default)(client, cosmosConfig);

  const result = { client, database };
  for (const collection of config.collections) {
    result[collection] = await (0, _collection2.default)(client, config, collection);
  }

  return result;
};